# portal-v2 ci

include:
  - /tools/ci/gitlab/default-child-include.gitlab-ci.yml

stages:
  - do-nothing
  - version
  - lint
  - test
  - build
  - publish
  - tag

# one job without any trigger rules is needed
# else the pipeline always fails!
portal-v2-no-op:
  stage: do-nothing
  extends:
    - .tag-all
    - .base-job-no-op

version-verify:
  stage: version
  extends:
    - .tag-all
    - .rule-child-trigger
    - .npm-node_modules-cache
    - .needs-child-needs-parent-jobs
  script:
    - !reference [.script-verify-version-app, script]

lint:
  stage: lint
  extends:
    - .tag-all
    - .rule-child-trigger
    - .needs-child-needs-parent-jobs
    - .npm-node_modules-cache
    - .script-nx-lint

test:
  stage: test
  extends:
    - .tag-all
    - .rule-child-trigger
    - .needs-child-needs-parent-jobs
    - .npm-node_modules-cache
    - .script-nx-test

build:
  stage: build
  extends:
    - .tag-all
    - .rule-child-trigger
    - .needs-child-needs-parent-jobs
    - .npm-node_modules-cache
    - .script-nx-build

publish:
  stage: publish
  extends:
    - .tag-all
    - .rule-only-main-and-child-trigger
    - .docker-build-and-push
    - .npm-node_modules-cache
  variables:
    DOCKER_PATH: "tools/docker/${PROJECT_NAME}/"
  script:
    - !reference [.script-get-app-version, script]
    - !reference [.docker-build-and-push, script]
  needs:
    - !reference [.needs-child-needs-parent-jobs, needs]
    - job: version-verify
    - job: lint
    - job: test
    - job: build

tag-release:
  stage: tag
  extends:
    - .tag-all
    - .rule-only-main-and-child-trigger
    - .script-ci-bot-git-tag-project
  script:
    - !reference [.script-get-app-version, script]
    - !reference [.script-ci-bot-git-tag-project, script]
  needs:
    - !reference [.needs-child-needs-parent-jobs, needs]
    - job: version-verify
    - job: publish
